import iopro
from AdapterDict import *


all_polls = {'president' : 'http://elections.huffingtonpost.com/pollster/2012-general-election-romney-vs-obama.csv',
             'obama-favorables' : 'http://elections.huffingtonpost.com/pollster/obama-favorable-rating.csv',
             'romney-favorables' : 'http://elections.huffingtonpost.com/pollster/mitt-romney-favorability.csv'}

class Polls(AdapterDict):
    """ 2012 Election polling data """

    def __init__(self):
        super(Polls, self).__init__()

        self.known_keys = all_polls.keys()

    def make_adapter(self, name):

        if name not in self.known_keys:
            raise KeyError('Invalid poll type')

        url = all_polls[name]

        return iopro.text_adapter(url, parser='csv')


if __name__ == '__main__':
    polls = Polls()
    print polls.keys()
    print polls['president'][:]

