import iopro
from AdapterDict import *


class WikiLogs(AdapterDict):
    """
    WikiLog Data Source: http://dumps.wikimedia.org/other/pagecounts-raw/.
    Any wiki dump data can be accessed like so
    wikilog['2011040707'][:100] (first 100 rows of April 7th 2011 07 UTC )
    """

    def make_adapter(self, pagecounts):

        if len(pagecounts) != 10:
            print 'Invalid DatTime Time. Please Use the format\n 2012010101 for 2012 January 1st at 01 hour'

       
        year = pagecounts[:4]
        month = pagecounts[4:6]
        day = pagecounts[6:8]
        hour = pagecounts[8:10]
        
        filename = 'pagecounts-'+year+month+day+'-'+hour+'0000.gz'

        #alternate filename
        filename1 = 'pagecounts-'+year+month+day+'-'+hour+'0001.gz'

        url = "http://dumps.wikimedia.org/other/pagecounts-raw/%s/%s-%s/%s" % (year,year,month,filename)

        # The following won't work without IOPro index-refactor2 branch 
        #index_filename = pagecounts + '.idx'
        #dataAdapter = iopro.text_adapter(url, delimiter=' ', compression='gzip', field_names=False, indexing=True, index_filename=index_filename)

        dataAdapter = iopro.text_adapter(url, delimiter=' ', compression='gzip', field_names=False, infer_types=False)
        
        dataAdapter.set_field_types({0:'object', 1:'object', 2:'i4', 3:'i8'})

        # Set dtype for each field in record
        dataAdapter.set_converter(1, str)

        return dataAdapter
           

if __name__ == '__main__':
    wikilogs = WikiLogs()
    print wikilogs.keys()
    print wikilogs['2011040707'][:]

