import iopro
from AdapterDict import *


class Genomes(AdapterDict):
    """ 1000 Genomes """

    def __init__(self, aws_access_key, aws_secret_key):
        super(Genomes, self).__init__()

        self.aws_access_key = aws_access_key
        self.aws_secret_key = aws_secret_key

    def make_adapter(self, name):

        # First two parameters are access key and secret key for accessing S3 data on AWS.
        # Third parameter is S3 bucket name.
        # Fourth parameter is key name in bucket (csv file name to parse)
        adapter = iopro.s3_text_adapter(self.aws_access_key, self.aws_secret_key,
            '1000genomes', name, parser='csv', compression='gzip', field_names=False)
    
        return adapter


if __name__ == '__main__':
    aws_access_key = ''
    aws_secret_key = ''
    genomes = Genomes(aws_access_key, aws_secret_key)
    print genomes.keys()
    print genomes['data/HG00115/sequence_read/ERR018519.filt.fastq.gz'][0:100]
